/*
 * Copyright 2022 LogMeIn
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#pragma once

#include "asyncly/task/Cancelable.h"

#include <memory>

namespace asyncly {

class AutoCancelable {
  public:
    AutoCancelable(const std::shared_ptr<Cancelable>& cancelable)
        : _cancelable(cancelable)
    {
    }
    virtual ~AutoCancelable()
    {
        _cancelable->cancel();
    }

  private:
    const std::shared_ptr<Cancelable> _cancelable;
};
using AutoCancelablePtr = std::shared_ptr<AutoCancelable>;

} // namespace asyncly
